#include <math.h>

inline double getBendingAndTwistEnergy (
  double bendingStiffness,
  double twistStiffness,
  double liReference,
  double *kappaOriginal,
  double referenceTwist,
  double *normalReferenceOriginal1,
  double *tangentReferenceOriginal1,
  double *normalReferenceOriginal2,
  double *tangentReferenceOriginal2,
  double referenceFrameTwist,
  double *x1,
  double *x2,
  double *x3,
  double theta1,
  double theta2)
{
  double t1;
  double t10;
  double t104;
  double t11;
  double t111;
  double t124;
  double t127;
  double t139;
  double t14;
  double t149;
  double t15;
  double t150;
  double t162;
  double t17;
  double t172;
  double t173;
  double t18;
  double t181;
  double t183;
  double t185;
  double t187;
  double t189;
  double t19;
  double t191;
  double t193;
  double t194;
  double t195;
  double t201;
  double t202;
  double t208;
  double t209;
  double t217;
  double t22;
  double t222;
  double t224;
  double t226;
  double t23;
  double t231;
  double t238;
  double t241;
  double t251;
  double t254;
  double t26;
  double t262;
  double t266;
  double t27;
  double t279;
  double t283;
  double t299;
  double t30;
  double t31;
  double t315;
  double t318;
  double t321;
  double t322;
  double t33;
  double t330;
  double t332;
  double t334;
  double t339;
  double t34;
  double t346;
  double t35;
  double t359;
  double t362;
  double t37;
  double t373;
  double t38;
  double t384;
  double t39;
  double t391;
  double t393;
  double t4;
  double t41;
  double t42;
  double t43;
  double t45;
  double t47;
  double t5;
  double t52;
  double t53;
  double t54;
  double t56;
  double t58;
  double t6;
  double t60;
  double t62;
  double t64;
  double t66;
  double t67;
  double t68;
  double t74;
  double t75;
  double t81;
  double t82;
  double t9;
  double t90;
  double t95;
  double t97;
  double t99;
  t1 = x2[0];
  t4 = t1 - 0.1e1 * x1[0];
  t5 = t4 * t4;
  t6 = x2[1];
  t9 = t6 - 0.1e1 * x1[1];
  t10 = t9 * t9;
  t11 = x2[2];
  t14 = t11 - 0.1e1 * x1[2];
  t15 = t14 * t14;
  t17 = sqrt(t5 + t10 + t15);
  t18 = 0.1e1 / t17;
  t19 = t18 * t4;
  t22 = x3[0] - 0.1e1 * t1;
  t23 = t22 * t22;
  t26 = x3[1] - 0.1e1 * t6;
  t27 = t26 * t26;
  t30 = x3[2] - 0.1e1 * t11;
  t31 = t30 * t30;
  t33 = sqrt(t23 + t27 + t31);
  t34 = 0.1e1 / t33;
  t35 = t34 * t22;
  t37 = 0.1e1 * t19 * t35;
  t38 = t18 * t9;
  t39 = t34 * t26;
  t41 = 0.1e1 * t38 * t39;
  t42 = t18 * t14;
  t43 = t34 * t30;
  t45 = 0.1e1 * t42 * t43;
  t47 = 0.1e1 / (0.1e1 + t37 + t41 + t45);
  t52 = 0.1e1 * t38 * t43 - 0.1e1 * t42 * t39;
  t53 = t47 * t52;
  t54 = cos(theta1);
  t56 = tangentReferenceOriginal1[0] * t18;
  t58 = 0.1e1 * t56 * t4;
  t60 = tangentReferenceOriginal1[1] * t18;
  t62 = 0.1e1 * t60 * t9;
  t64 = tangentReferenceOriginal1[2] * t18;
  t66 = 0.1e1 * t64 * t14;
  t67 = t58 + t62 + t66;
  t68 = normalReferenceOriginal1[2];
  t74 = 0.1e1 * t60 * t14 - 0.1e1 * t64 * t9;
  t75 = normalReferenceOriginal1[1];
  t81 = -0.1e1 * t56 * t14 + 0.1e1 * t64 * t4;
  t82 = normalReferenceOriginal1[0];
  t90 = 0.1e1 * t56 * t9 - 0.1e1 * t60 * t4;
  t95 = (t68 * t90 + t74 * t82 + t75 * t81) / (0.1e1 + t58 + t62 + t66);
  t97 = t67 * t68 + t74 * t75 - t81 * t82 + t90 * t95;
  t99 = sin(theta1);
  t104 = t67 * t75 - t68 * t74 + t81 * t95 + t82 * t90;
  t111 = t67 * t82 + t68 * t81 + t74 * t95 - t75 * t90;
  t124 = (0.1e1 * t19 * t111 + 0.1e1 * t38 * t104 + 0.1e1 * t42 * t97) * (0.1e1 - t54);
  t127 = t54 * t97 + t99 * (0.1e1 * t19 * t104 - 0.1e1 * t38 * t111) + 0.1e1 * t124 * t42;
  t139 = t54 * t104 + t99 * (-0.1e1 * t19 * t97 + 0.1e1 * t42 * t111) + 0.1e1 * t124 * t38;
  t149 = -0.1e1 * t19 * t43 + 0.1e1 * t42 * t35;
  t150 = t47 * t149;
  t162 = t54 * t111 + t99 * (0.1e1 * t38 * t97 - 0.1e1 * t42 * t104) + 0.1e1 * t124 * t19;
  t172 = 0.1e1 * t19 * t39 - 0.1e1 * t38 * t35;
  t173 = t47 * t172;
  t181 = cos(theta2);
  t183 = tangentReferenceOriginal2[0] * t34;
  t185 = 0.1e1 * t183 * t22;
  t187 = tangentReferenceOriginal2[1] * t34;
  t189 = 0.1e1 * t187 * t26;
  t191 = tangentReferenceOriginal2[2] * t34;
  t193 = 0.1e1 * t191 * t30;
  t194 = t185 + t189 + t193;
  t195 = normalReferenceOriginal2[2];
  t201 = 0.1e1 * t187 * t30 - 0.1e1 * t191 * t26;
  t202 = normalReferenceOriginal2[1];
  t208 = -0.1e1 * t183 * t30 + 0.1e1 * t191 * t22;
  t209 = normalReferenceOriginal2[0];
  t217 = 0.1e1 * t183 * t26 - 0.1e1 * t187 * t22;
  t222 = (t195 * t217 + t201 * t209 + t202 * t208) / (0.1e1 + t185 + t189 + t193);
  t224 = t194 * t195 + t201 * t202 - t208 * t209 + t217 * t222;
  t226 = sin(theta2);
  t231 = t194 * t202 - t195 * t201 + t208 * t222 + t209 * t217;
  t238 = t194 * t209 + t195 * t208 + t201 * t222 - t202 * t217;
  t241 = 0.1e1 * t35 * t231 - 0.1e1 * t39 * t238;
  t251 = (0.1e1 * t35 * t238 + 0.1e1 * t39 * t231 + 0.1e1 * t43 * t224) * (0.1e1 - t181);
  t254 = t181 * t224 + t226 * t241 + 0.1e1 * t251 * t43;
  t262 = -0.1e1 * t35 * t224 + 0.1e1 * t43 * t238;
  t266 = t181 * t231 + t226 * t262 + 0.1e1 * t251 * t39;
  t279 = 0.1e1 * t39 * t224 - 0.1e1 * t43 * t231;
  t283 = t181 * t238 + t226 * t279 + 0.1e1 * t251 * t35;
  t299 = pow(0.1000000000e1 * t53 * (0.1e1 * t38 * t127 - 0.1e1 * t42 * t139) + 0.1000000000e1 * t150 * (-0.1e1 * t19 * t127 + 0.1e1 * t42 * t162) + 0.1000000000e1 * t173 * (0.1e1 * t19 * t139 - 0.1e1 * t38 * t162) + 0.1000000000e1 * t53 * (0.1e1 * t39 * t254 - 0.1e1 * t43 * t266) + 0.1000000000e1 * t150 * (-0.1e1 * t35 * t254 + 0.1e1 * t43 * t283) + 0.1000000000e1 * t173 * (0.1e1 * t35 * t266 - 0.1e1 * t39 * t283) - 0.1e1 * kappaOriginal[0], 0.2e1);
  t315 = pow(-0.1000000000e1 * t53 * t162 - 0.1000000000e1 * t150 * t139 - 0.1000000000e1 * t173 * t127 - 0.1000000000e1 * t53 * t283 - 0.1000000000e1 * t150 * t266 - 0.1000000000e1 * t173 * t254 - 0.1e1 * kappaOriginal[1], 0.2e1);
  t318 = 0.1e1 / liReference;
  t321 = cos(referenceFrameTwist);
  t322 = t37 + t41 + t45;
  t330 = (t104 * t149 + t111 * t52 + t172 * t97) * t47;
  t332 = -t104 * t172 + t111 * t322 + t149 * t97 + t330 * t52;
  t334 = sin(referenceFrameTwist);
  t339 = t104 * t52 - t111 * t149 + t172 * t330 + t322 * t97;
  t346 = t104 * t322 + t111 * t172 + t149 * t330 - t52 * t97;
  t359 = (0.1e1 * t35 * t332 + 0.1e1 * t39 * t346 + 0.1e1 * t43 * t339) * (0.1e1 - t321);
  t362 = t321 * t332 + t334 * (0.1e1 * t39 * t339 - 0.1e1 * t43 * t346) + 0.1e1 * t359 * t35;
  t373 = t321 * t346 + t334 * (-0.1e1 * t35 * t339 + 0.1e1 * t43 * t332) + 0.1e1 * t359 * t39;
  t384 = t321 * t339 + t334 * (0.1e1 * t35 * t346 - 0.1e1 * t39 * t332) + 0.1e1 * t359 * t43;
  t391 = atan2(t241 * t384 + t262 * t373 + t279 * t362, t224 * t384 + t231 * t373 + t238 * t362);
  t393 = pow(theta2 - theta1 + referenceFrameTwist - t391 - referenceTwist, 0.2e1);
  return(0.5000000000e0 * bendingStiffness * (t299 + t315) * t318 + 0.5000000000e0 * twistStiffness * t393 * t318);
}
